NetBSD/games/wtf/wtf
hubertf e5fa46c791 Teach wtf(6) about pkgsrc's help facility:
% cd /usr/pkgsrc/audio/qsynth
% wtf subst
subst: ===> mk/subst.mk:
# This Makefile fragment implements a general text replacement facility.
...
2007-08-06 21:14:36 +00:00

96 lines
1.5 KiB
Bash

#!/bin/sh
#
# $NetBSD: wtf,v 1.15 2007/08/06 21:14:36 hubertf Exp $
#
# Public domain
#
PROGNAME=`basename $0`
usage() {
echo "usage: $PROGNAME [-f dbfile] [is] <acronym>"
exit 1
}
acronyms=${ACRONYMDB:-`ls /usr/share/misc/acronyms* 2>/dev/null`}
if [ "$acronyms" = "" ]; then
echo "$PROGNAME: acronyms database not found!" >&2
exit 1
fi
args=`getopt f: $*`
if [ $? -ne 0 ]; then
usage
fi
set -- $args
while [ $# -gt 0 ]; do
case "$1" in
-f)
acronyms=$2; shift
;;
--)
shift; break
;;
esac
shift
done
if [ "$1" = "is" ] ; then
shift
fi
if [ $# -lt 1 ] ; then
usage
fi
for f in $acronyms
do
if [ ! -f $f ]; then
echo "$PROGNAME: cannot open acronyms database file \`$f'" >&2
exit 1
fi
done
rv=0
while [ $# -gt 0 ] ; do
# Search acronyms list first
target=`echo $1 | tr '[a-z]' '[A-Z]'`
ans=`fgrep -h $target $acronyms 2>/dev/null \
| sed -ne "\|^$target[[:space:]]|s|^$target[[:space:]]*||p"`
if [ "$ans" != "" ] ; then
echo "$target: $ans"
shift ; continue
fi
# Try whatis(1) next
ans=`whatis $1 2>/dev/null`
if [ $? -eq 0 ] ; then
echo "$ans" | sort -u
shift ; continue
fi
# Try pkg_info(1) next
ans=`pkg_info -qc $1 2> /dev/null`
if [ $? -eq 0 ] ; then
echo "$1: $ans"
shift ; continue
fi
# Try querying pkgsrc's help facility next
if [ -f ../../mk/bsd.pkg.mk ] ; then
ans=`make help topic="$1"`
if [ $? -eq 0 ] ; then
echo "$1: $ans"
shift ; continue
fi
fi
# Give up!
echo "$PROGNAME: I don't know what $1 means!" 1>&2
rv=1
shift
done
exit $rv